(* -----------------------------------------------------------------------------
  Using TIEGdiPlus
  For A Programmers Introduction To Using ImageEn Library Suite
  Copyright  2015   : Copyright Adirondack Software & Graphics
  Last Modification  : 03-08-2015
  Source File        : uMain.pas
  Compiler           : Delphi XE7
  Operating System   : Windows 8.1
  This file is copyright  W W Miller, 1986-2015.
  This demo will only run on Windows operating systems Vista or higher
  and requires Delphi 2010 or higher
  It may be used without restriction. This code distributed on an "AS IS"
  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
  --------------------------------------------------------------------------- *)

unit Unit1;
{$WARN SYMBOL_PLATFORM OFF}
{$WARN UNIT_PLATFORM OFF}

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics, Vcl.Controls, Vcl.Forms, System.UITypes,
  Vcl.Dialogs, Vcl.ExtDlgs, Vcl.ExtCtrls, Vcl.ComCtrls, Vcl.Buttons,
  Vcl.StdCtrls, Winapi.CommDlg, Vcl.Menus, Vcl.ImgList, Vcl.Themes, Vcl.Mask,
  ieview, imageenview, imageenio, imageenproc, iegdiplus;

const
  WM_AFTER_SHOW = WM_USER + 300;

type
  TForm1 = class(TForm)
    ImageEnView1: TImageEnView;
    Panel1: TPanel;
    Open1: TButton;
    ImageEnProc1: TImageEnProc;
    ImageEnIO1: TImageEnIO;
    Undo1: TButton;
    Close1: TButton;
    Fit1: TSpeedButton;
    New1: TButton;
    Save1: TButton;
    SaveAs1: TButton;
    StatusBar1: TStatusBar;
    PopupMenuColors1: TPopupMenu;
    ConvertTo32Bit1: TMenuItem;
    ConvertTo24Bit1: TMenuItem;
    ConvertTo8Bit1: TMenuItem;
    ConvertTo4Bit1: TMenuItem;
    Colors2: TButton;
    ImageList1: TImageList;
    TaskDialog1: TTaskDialog;
    Button1: TButton;
    PopupMenuSelect1: TPopupMenu;
    None1: TMenuItem;
    Selection1: TMenuItem;
    N1: TMenuItem;
    ZoomIn1: TButton;
    ZoomOut1: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ScrollBox1: TScrollBox;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    BrushShape1: TShape;
    Label10: TLabel;
    BrushAlpha1: TEdit;
    UpDown4: TUpDown;
    BrushOpacity1: TEdit;
    UpDown5: TUpDown;
    BrushColor1: TColorBox;
    FillTolerance1: TEdit;
    UpDown7: TUpDown;
    ScrollBarBrushOpacity1: TScrollBar;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label2: TLabel;
    Label7: TLabel;
    PenShape1: TShape;
    PenColor1: TColorBox;
    PenAlpha1: TEdit;
    UpDown2: TUpDown;
    PenOpacity1: TEdit;
    UpDown3: TUpDown;
    PenType1: TRadioGroup;
    RoundRectRadius1: TEdit;
    UpDown1: TUpDown;
    BrushSize1: TEdit;
    UpDown6: TUpDown;
    PenSizeScrollBar1: TScrollBar;
    ScrollBarPenOpacity1: TScrollBar;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    ColorUnderCursor1: TShape;
    OpacityUnderCursor1: TLabel;
    AlphaUnderCursor1: TLabel;
    Color1: TLabel;
    Row1: TLabel;
    Column1: TLabel;
    GroupBox5: TGroupBox;
    Draw1: TSpeedButton;
    Line1: TSpeedButton;
    Rectangle1: TSpeedButton;
    FilledRectangle1: TSpeedButton;
    RoundRectangle1: TSpeedButton;
    FilledRoundRectangle1: TSpeedButton;
    Ellipse1: TSpeedButton;
    FilledEllipse1: TSpeedButton;
    Fill1: TSpeedButton;
    PickColor1: TSpeedButton;
    FillAlpha1: TSpeedButton;
    GroupBox7: TGroupBox;
    Label15: TLabel;
    Label16: TLabel;
    BackgroundColor1: TColorBox;
    BackgroundAlphaColor1: TColorBox;
    GroupBox4: TGroupBox;
    Label9: TLabel;
    AntiAlias1: TCheckBox;
    CenterImage1: TCheckBox;
    AlphaChannel1: TCheckBox;
    Grid1: TCheckBox;
    UseGDIPlus1: TCheckBox;
    IECanvasSmoothingMode1: TComboBox;
    PopupMenuMRF1: TPopupMenu;
    MRF1: TMenuItem;
    Erase1: TSpeedButton;
    AddLayer1: TButton;
    DeleteLayer1: TButton;
    MergeLayer1: TButton;
    PanZoom1: TMenuItem;
    PopupMenuImageEnView1: TPopupMenu;
    New2: TMenuItem;
    Open2: TMenuItem;
    Save2: TMenuItem;
    SaveAs2: TMenuItem;
    Undo2: TMenuItem;
    AddLayer2: TMenuItem;
    DeleteLayer2: TMenuItem;
    MergeLayer2: TMenuItem;
    MRF2: TMenuItem;
    Recent1: TMenuItem;
    Clear1: TButton;
    Clear2: TMenuItem;
    Text1: TSpeedButton;
    GroupBox6: TGroupBox;
    Edit1: TEdit;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;
    procedure Open1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ImageEnView1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageEnView1MouseLeave(Sender: TObject);
    procedure ImageEnView1MouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure ImageEnView1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Undo1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure Fit1Click(Sender: TObject);
    procedure BrushAlpha1Change(Sender: TObject);
    procedure BrushOpacity1Change(Sender: TObject);
    procedure Grid1Click(Sender: TObject);
    procedure AlphaChannel1Click(Sender: TObject);
    procedure CenterImage1Click(Sender: TObject);
    procedure UseGDIPlus1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure ImageEnView1DrawBackBuffer(Sender: TObject);
    procedure BrushColor1Change(Sender: TObject);
    procedure PenAlpha1Change(Sender: TObject);
    procedure PenOpacity1Change(Sender: TObject);
    procedure Rectangle1Click(Sender: TObject);
    procedure FilledRectangle1Click(Sender: TObject);
    procedure RoundRectangle1Click(Sender: TObject);
    procedure FilledRoundRectangle1Click(Sender: TObject);
    procedure Ellipse1Click(Sender: TObject);
    procedure FilledEllipse1Click(Sender: TObject);
    procedure ConvertTo32Bit1Click(Sender: TObject);
    procedure ConvertTo4Bit1Click(Sender: TObject);
    procedure ConvertTo8Bit1Click(Sender: TObject);
    procedure ConvertTo24Bit1Click(Sender: TObject);
    procedure ImageEnView1ViewChange(Sender: TObject; Change: Integer);
    procedure Draw1Click(Sender: TObject);
    procedure BrushSize1Change(Sender: TObject);
    procedure ImageEnView1MouseEnter(Sender: TObject);
    procedure PenType1Click(Sender: TObject);
    procedure PenColor1Change(Sender: TObject);
    procedure Fill1Click(Sender: TObject);
    procedure PickColor1Click(Sender: TObject);
    procedure FillAlpha1Click(Sender: TObject);
    procedure ScrollBarBrushOpacity1Change(Sender: TObject);
    procedure PenSizeScrollBar1Change(Sender: TObject);
    procedure ZoomIn1Click(Sender: TObject);
    procedure ZoomOut1Click(Sender: TObject);
    procedure ScrollBarPenOpacity1Change(Sender: TObject);
    procedure None1Click(Sender: TObject);
    procedure Selection1Click(Sender: TObject);
    procedure Line1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormDestroy(Sender: TObject);
    procedure Erase1Click(Sender: TObject);
    procedure AddLayer1Click(Sender: TObject);
    procedure DeleteLayer1Click(Sender: TObject);
    procedure MergeLayer1Click(Sender: TObject);
    procedure PanZoom1Click(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure Text1Click(Sender: TObject);
  private
    { Private declarations }
    AIniFilename: string;
    AFileName: string;
    ALastFolder: string;
    AStartX: Integer;
    AStartY: Integer;
    ALastX: Integer;
    ALastY: Integer;
    APX: Integer;
    APY: Integer;
    ADrawing: Boolean;
    AMX: Integer;
    AMY: Integer;
    ANewCanvas: TIECanvas;
    AAlphaChanging: Boolean;
    AOpacityChanging: Boolean;
    AZoom: double;
    procedure MyUndo(ie: TImageEnView);
    procedure DrawBrush(X: Integer; Y: Integer);
    procedure DrawLine;
    procedure DrawRectangle;
    procedure DrawFilledRectangle;
    procedure DrawRoundRectangle;
    procedure DrawFilledRoundRectangle;
    procedure DrawEllipse;
    procedure DrawFilledEllipse;
    procedure WmAfterShow(var Msg: TMessage); message WM_AFTER_SHOW;
    procedure UpdateUndoHint;
    procedure Cast_Color(BX: Integer; BY: Integer);
    procedure Cast_Alpha(BX, BY: Integer);
    procedure Pick_Color(BY: Integer; BX: Integer);
    procedure WriteIni(AIniFilename: string);
    procedure ReadIni(AIniFilename: string);
    procedure EraseBrush(X, Y: Integer);
    procedure EnableTouch(AValue: Boolean);
  public
    { Public declarations }
  end;

const
  crPotOPaint = 1;
  crPickColor = 2;

var
  Form1: TForm1;

implementation

uses Winapi.ShellAPI, System.IniFiles, System.Types, Winapi.ShlObj,
  Winapi.ActiveX, Vcl.Touch.Gestures, Winapi.SHFolder, System.StrUtils,
  hyieutils, hyiedefs, uNewImage;

{$R *.dfm}
{$R CursorTools.res}

function AppDataFolder: string;
{ Find AppData folder location. }
var
  ir: BOOL;
  iPath: array [0 .. MAX_PATH] of char;
begin
  ir := Winapi.ShlObj.ShGetSpecialFolderPath(0, iPath,
    CSIDL_LOCAL_APPDATA, False);
  if not ir then
    raise Exception.Create('Could not find LocalAppData folder location.');
  Result := IncludeTrailingPathDelimiter(iPath);
end;

procedure FreePIDL(PIDL: Winapi.ShlObj.PItemIDList);
var
  Malloc: Winapi.ActiveX.IMalloc;
begin
  if Winapi.Windows.Succeeded(Winapi.ShlObj.SHGetMalloc(Malloc)) then
    Malloc.Free(PIDL);
end;

function PIDLToFolderPath(PIDL: Winapi.ShlObj.PItemIDList): string;
begin
  SetLength(Result, Winapi.Windows.MAX_PATH);
  if Winapi.ShlObj.SHGetPathFromIDList(PIDL, PChar(Result)) then
    Result := PChar(Result)
  else
    Result := '';
end;

function IsSpecialFolderSupported(CSIDL: Integer): Boolean;
var
  iPIDL: Winapi.ShlObj.PItemIDList;
begin
  Result := Winapi.Windows.Succeeded(Winapi.ShlObj.SHGetSpecialFolderLocation(0,
    CSIDL, iPIDL));
  if Result then
    FreePIDL(iPIDL);
end;

function SpecialFolderPath(CSIDL: Integer): string;
{ Returns the full path to a special file system folder
  specified by a CSIDL constant FolderID. }
var
  iPIDL: Winapi.ShlObj.PItemIDList;
begin
  Result := '';
  if Winapi.Windows.Succeeded(Winapi.ShlObj.SHGetSpecialFolderLocation(0, CSIDL,
    iPIDL)) then
  begin
    try
      Result := PIDLToFolderPath(iPIDL);
    finally
      FreePIDL(iPIDL);
    end;
  end
end;

function DesktopFolder: string;
{ Find Desktop folder location. }
var
  iPath: string;
begin
  if IsSpecialFolderSupported(CSIDL_DESKTOP) then
  begin
    Result := iPath;
    iPath := SpecialFolderPath(CSIDL_DESKTOP);
  end
  else
    raise Exception.Create('Could not find Desktop folder location.');
end;

function DocumentsFolder: string;
{ Find Documents folder location. }
var
  iPath: string;
begin
  if IsSpecialFolderSupported(CSIDL_PERSONAL) then
  begin
    iPath := SpecialFolderPath(CSIDL_PERSONAL);
    Result := iPath;
  end
  else
    raise Exception.Create('Could not find Documents folder location.');
end;

procedure SetSquarePen(ACanvas: TCanvas; AColor: TColor; AWidth: Integer);
{ Set the pens endcaps to square. }
var
  iLogBrush: TLOGBRUSH;
begin
  if AWidth > 1 then
  begin
    iLogBrush.lbStyle := BS_Solid;
    iLogBrush.lbColor := AColor;
    iLogBrush.lbHatch := 0;
    ACanvas.Pen.Handle := ExtCreatePen(PS_Geometric or PS_Solid or
      PS_ENDCAP_SQUARE, AWidth, iLogBrush, 0, nil);
  end
  else
  begin
    ACanvas.Pen.Color := AColor;
    ACanvas.Pen.Width := AWidth;
    ACanvas.Pen.Style := psSolid;
  end;
end;

function EllipsifyText(const AsPath: Boolean; const Text: string;
  const Canvas: Vcl.Graphics.TCanvas; const MaxWidth: Integer): string;
{ Shortens text if necessary to fit within a specified number of pixels on a
  given canvas. If AsPath is True text is shortened path-wise by inserting an
  ellipsis in the text body, otherwise it is trunctated and an ellipsis is
  appended. }
var
  TempPChar: PChar;
  TempRect: TRect;
  Params: UINT;
begin
  if Text = '' then
    exit;
  GetMem(TempPChar, Length(Text) * SizeOf(Text));
  try
    TempPChar := System.SysUtils.StrPCopy(TempPChar, Text);
    TempRect := System.Classes.Rect(0, 0, MaxWidth, High(Integer));
    if AsPath then
      Params := Winapi.Windows.DT_PATH_ELLIPSIS
    else
      Params := Winapi.Windows.DT_END_ELLIPSIS;
    Params := Params + Winapi.Windows.DT_MODIFYSTRING +
      Winapi.Windows.DT_CALCRECT;
    Winapi.Windows.DrawTextEx(Canvas.Handle, TempPChar, -1, TempRect,
      Params, nil);
    Result := System.SysUtils.StrPas(TempPChar);
  finally
    FreeMem(TempPChar, Length(Text) * SizeOf(Text));
  end;
end;

procedure ClearStatusbar(const AStatusBar: TStatusBar);
{ Clear the statusbar panels. }
var
  i: Integer;
begin
  for i := 0 to AStatusBar.Panels.Count - 1 do
    AStatusBar.Panels[i].Text := '';
end;

function ColorToPrettyName(const AColor: TColor): string;
{ Return a string of a TColor from AColor. }
var
  iColor: string;
begin
  Result := '';
  iColor := ColorToString(AColor);
  if AnsiContainsText(iColor, 'cl') then
    Delete(iColor, 1, 2);
  Result := iColor;
end;

function DitherColor(AColor: TColor; AAlpha: Integer): TColor;
{ Dither a 32-bit color(with alpha value) to TColor.  This functions
  correctly for all colors except for clwhite. }
var
  iRGB: TRGB;
begin
  iRGB := TColor2TRGB(AColor);
  iRGB.r := trunc(AAlpha / 255 * iRGB.r) + (255 - AAlpha);
  iRGB.g := trunc(AAlpha / 255 * iRGB.g) + (255 - AAlpha);
  iRGB.b := trunc(AAlpha / 255 * iRGB.b) + (255 - AAlpha);
  Result := TRGB2TColor(iRGB);
end;

function ContrastingColor(AColor: TColor): TColor;
{ Return the contrasting color of the passed color. }
begin
  if ((AColor and $FF) * 77 + ((AColor shr 8) and $FF) * 150 +
    ((AColor shr 16) and $FF) * 29) > 127 * 256 then
    Result := clBlack
  else
    Result := clWhite;
end;

function AddThousandSeparator(const S: string; const C: char): string;
{ Add a specified thousand separator in the correct location in a string }
var
  i: Integer;
begin
  Result := S;
  i := Length(S) - 2;
  while i > 1 do
  begin
    Insert(C, Result, i);
    i := i - 3;
  end;
end;

function AddDefThousandSeparator(const S: string): string;
{ Add the thousands separator from the default locale in the correct
  location in a string. }
begin
  Result := AddThousandSeparator(S,
    System.SysUtils.FormatSettings.ThousandSeparator);
end;

function IntegerToString(const Value: Integer): string;
{ Convert value into a string with thousands seperator. }
begin
  Result := AddDefThousandSeparator(IntToStr(Value));
end;

function FloatToFixed(const AValue: Extended; const ADecimalPlaces: Byte;
  const ASeparateThousands: Boolean): string;
{ Convert a floating point value to a fixed format string. The number of
  decimal places and wether thousands should be separated can be specified. }
const
  cFmtSpec: array [Boolean] of char = ('f', 'n');
begin
  Result := System.SysUtils.Format('%.*' + cFmtSpec[ASeparateThousands],
    [ADecimalPlaces, AValue]);
end;

procedure IETextOut(Canvas: TCanvas; X, Y: Integer; angle: Integer;
  const Text: string);
var
  iLogFont: TLogFont;
begin
  with Canvas do
  begin
    GetObject(Font.Handle, SizeOf(TLogFont), @iLogFont);
    iLogFont.lfEscapement := angle * 10;
    iLogFont.lfQuality := 3;
    Font.Handle := CreateFontIndirect(iLogFont);
    TextOut(X, Y, Text);
  end;
end;

function DelText(const Needle, Haystack: string): string;
{ Deletes the first occurrence of text Needle from text HayStack and returns
  the resulting string. HayStack is returned unchanged if it does not contain
  Needle. The search is case insensitive. }
var
  StartIdx: Integer;
begin
  Result := Haystack;
  StartIdx := System.SysUtils.AnsiPos(System.SysUtils.AnsiLowerCase(Needle),
    System.SysUtils.AnsiLowerCase(Haystack));
  if StartIdx > 0 then
    Delete(Result, StartIdx, Length(Needle));
end;

{ TForm1 }
procedure TForm1.ReadIni(AIniFilename: string);
{ Read parameters from inifile. }
var
  iIniFile: TIniFile;
begin
  iIniFile := TIniFile.Create(AIniFilename);
  try
    with iIniFile do
    begin
      Fit1.Down := iIniFile.ReadBool('Main', 'Fit', True);
    end;
  finally
    iIniFile.Free;
  end;
end;

procedure TForm1.WriteIni(AIniFilename: string);
{ Write parameters to inifile. }
var
  iIniFile: TIniFile;
begin
  iIniFile := TIniFile.Create(AIniFilename);
  try
    with iIniFile do
    begin
      iIniFile.WriteBool('Main', 'Fit', Fit1.Down);
    end;
  finally
    iIniFile.Free;
  end;
end;

procedure TForm1.MergeLayer1Click(Sender: TObject);
begin
  ImageEnView1.LayersMerge(0, ImageEnView1.LayersCurrent, True);
  StatusBar1.Panels[9].Text := 'Layers: ' + IntToStr(ImageEnView1.LayersCount);
  DeleteLayer1.Enabled := ImageEnView1.LayersCount > 1;
  MergeLayer1.Enabled := ImageEnView1.LayersCount > 1;
  ImageEnView1.SetFocus;
end;

procedure TForm1.MyUndo(ie: TImageEnView);
var
  ix1, iy1, ix2, iy2: Integer;
begin
  ix1 := AStartX;
  iy1 := AStartY;
  ix2 := ALastX;
  iy2 := ALastY;
  OrdCor(ix1, iy1, ix2, iy2);
  ie.Proc.UndoRect(ix1 - StrToInt(BrushSize1.Text),
    iy1 - StrToInt(BrushSize1.Text), ix2 + StrToInt(BrushSize1.Text),
    iy2 + StrToInt(BrushSize1.Text));
end;

procedure TForm1.ZoomIn1Click(Sender: TObject);
{ Change the zoom. }
begin
  Fit1.Caption := IntegerToString(Round(ImageEnView1.Zoom)) + '%';
  AZoom := ImageEnView1.Zoom + 10;
  ImageEnView1.Zoom := AZoom;
  ZoomIn1.Hint := 'Zoom: ' + IntegerToString(Round(AZoom)) + '%';
end;

procedure TForm1.ZoomOut1Click(Sender: TObject);
{ Change the zoom. }
begin
  Fit1.Caption := IntegerToString(Round(ImageEnView1.Zoom)) + '%';
  AZoom := ImageEnView1.Zoom - 10;
  ImageEnView1.Zoom := ImageEnView1.Zoom - 10;
  ZoomOut1.Hint := 'Zoom: ' + IntegerToString(Round(AZoom)) + '%';
end;

procedure TForm1.AddLayer1Click(Sender: TObject);
var
  ilayer: Integer;
  iRGB: TRGB;
begin
  ImageEnView1.LayersSync := True;
  ilayer := ImageEnView1.LayersAdd;
  ImageEnView1.LayersCurrent := ilayer;
  ImageEnView1.CurrentLayer.name := AnsiString('Layer ' + IntToStr(ilayer));
  iRGB := ImageEnView1.IEBitmap.Pixels[0, ImageEnView1.IEBitmap.Height - 1];
  ImageEnView1.Proc.SetTransparentColors(iRGB, iRGB, 0);
  ImageEnView1.Update;
  DeleteLayer1.Enabled := ImageEnView1.LayersCount > 1;
  MergeLayer1.Enabled := ImageEnView1.LayersCount > 1;
  StatusBar1.Panels[9].Text := 'Layers: ' + IntToStr(ImageEnView1.LayersCount);
end;

procedure TForm1.AlphaChannel1Click(Sender: TObject);
{ Toggle the alphachannel visibility. }
begin
  ImageEnView1.EnableAlphaChannel := AlphaChannel1.Checked;
  ImageEnView1.Update;
end;

procedure TForm1.BrushAlpha1Change(Sender: TObject);
{ Change the opacity value. }
var
  ios: single;
  iOpacity: Integer;
begin
  if not AOpacityChanging then
  begin
    AAlphaChanging := True;
    ios := IEAlphaToOpacity(StrToInt(BrushAlpha1.Text));
    iOpacity := Round(ios);
    BrushOpacity1.Text := IntToStr(iOpacity);
    BrushShape1.Brush.Color := DitherColor(BrushColor1.Selected,
      StrToInt(BrushAlpha1.Text));
    AAlphaChanging := False;
  end;
end;

procedure TForm1.BrushColor1Change(Sender: TObject);
begin
  if StrToInt(BrushAlpha1.Text) = 255 then
    BrushShape1.Brush.Color := BrushColor1.Selected
  else
    BrushShape1.Brush.Color := DitherColor(BrushColor1.Selected,
      StrToInt(BrushAlpha1.Text));
  ImageEnView1.Update;
end;

procedure TForm1.BrushOpacity1Change(Sender: TObject);
{ Change the alpha value. }
var
  iAlpha: Integer;
  iOpacity: Integer;
begin
  if not AAlphaChanging then
  begin
    AOpacityChanging := True;
    iOpacity := StrToIntDef(BrushOpacity1.Text, 255);
    iAlpha := Round((iOpacity * 255) / 100);
    BrushAlpha1.Text := IntToStr(iAlpha);
    ImageEnView1.Update;
    BrushShape1.Brush.Color := DitherColor(BrushColor1.Selected, iAlpha);
    AOpacityChanging := False;
  end;
end;

procedure TForm1.BrushSize1Change(Sender: TObject);
begin
  if StrToInt(BrushSize1.Text) > 1 then
    ImageEnView1.HighlightedPixel := Point(-1, -1);
  ImageEnView1.Update;
  PenSizeScrollBar1.Position := StrToInt(BrushSize1.Text);
end;

procedure TForm1.Clear1Click(Sender: TObject);
begin
  ImageEnView1.IEBitmap.Allocate(ImageEnView1.Width, ImageEnView1.Height);
  ImageEnView1.IEBitmap.Fill(clWhite);
  ImageEnView1.Update;
  ImageEnView1.IO.Params.BitsPerSample := 8;
  ImageEnView1.IO.Params.SamplesPerPixel := 3;
  AFileName := IncludeTrailingPathDelimiter(DocumentsFolder) + 'Untitled.jpg';
  Caption := 'ImageEn GDI And GDIPlus Drawing- ' + AFileName;
  StatusBar1.Panels[0].Text := EllipsifyText(True, ExtractFilePath(AFileName),
    Canvas, StatusBar1.Panels[0].Width);
  StatusBar1.Panels[1].Text := EllipsifyText(False, ExtractFilename(AFileName),
    Canvas, StatusBar1.Panels[1].Width);
  StatusBar1.Panels[2].Text := 'Width: ' +
    IntegerToString(ImageEnView1.IEBitmap.Width);
  StatusBar1.Panels[3].Text := 'Height: ' +
    IntegerToString(ImageEnView1.IEBitmap.Height);
  StatusBar1.Panels[9].Text := 'Layers: ' + IntToStr(ImageEnView1.LayersCount);
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.ConvertTo24Bit1Click(Sender: TObject);
{ Convert the bitmap to 24Bit. }
var
  iColor: string;
  iExtension: string;
begin
  Screen.Cursor := crHourGlass;
  try
    iExtension := Lowercase(ExtractFileExt(AFileName));
    if iExtension = '.bmp' then
      ImageEnView1.IO.Params.BMP_HandleTransparency := True;
    ImageEnView1.DeSelect;
    ImageEnView1.IO.Params.BitsPerSample := 8;
    ImageEnView1.IO.Params.SamplesPerPixel := 3;
    if ImageEnView1.HasAlphaChannel then
      ImageEnView1.RemoveAlphaChannel;
    ImageEnView1.Update;
    iColor := 'RGB 24-Bit';
    ImageEnView1.BackgroundStyle := iebsSolid;
    ImageEnView1.Background := clWhite;
    StatusBar1.Panels[3].Text := iColor;
    if ImageEnView1.HasAlphaChannel then
      StatusBar1.Panels[4].Text := 'Has AlphaChannel'
    else
      StatusBar1.Panels[4].Text := 'No AlphaChannel';
    ImageEnView1.Bitmap.Modified := True;
    Undo1.Enabled := ImageEnView1.Proc.CanUndo;
    StatusBar1.Panels[7].Text := iColor;
    if ImageEnView1.HasAlphaChannel then
      StatusBar1.Panels[8].Text := 'Has AlphaChannel'
    else
      StatusBar1.Panels[8].Text := 'No AlphaChannel';
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.ConvertTo32Bit1Click(Sender: TObject);
{ Convert the bitmap to 32Bit. }
var
  iRGB: TRGB;
  iBX, iBY: Integer;
  iColor: string;
  iExtension: string;
begin
  Screen.Cursor := crHourGlass;
  try
    iExtension := Lowercase(ExtractFileExt(AFileName));
    if iExtension = '.bmp' then
      ImageEnView1.IO.Params.BMP_HandleTransparency := True;
    ImageEnView1.IO.Params.BitsPerSample := 8;
    ImageEnView1.IO.Params.SamplesPerPixel := 4;
    ImageEnView1.Update;
    iBX := 0;
    iBY := ImageEnView1.IEBitmap.Height - 1;
    iRGB := ImageEnView1.IEBitmap.Pixels[iBX, iBY];
    ImageEnView1.Proc.SetTransparentColors(iRGB, iRGB, 0);
    ImageEnView1.Update;
    iColor := 'RGBA 32-Bit';
    ImageEnView1.BackgroundStyle := iebsChessboard;
    ImageEnView1.Background := clBtnFace;
    StatusBar1.Panels[3].Text := iColor;
    ImageEnView1.HasAlphaChannel;
    if ImageEnView1.HasAlphaChannel then
      StatusBar1.Panels[4].Text := 'Has AlphaChannel'
    else
      StatusBar1.Panels[4].Text := 'No AlphaChannel';
    ImageEnView1.Bitmap.Modified := True;
    ImageEnView1.ImageChange;
    Undo1.Enabled := ImageEnView1.Proc.CanUndo;
    StatusBar1.Panels[7].Text := iColor;
    if ImageEnView1.HasAlphaChannel then
      StatusBar1.Panels[8].Text := 'Has AlphaChannel'
    else
      StatusBar1.Panels[8].Text := 'No AlphaChannel';
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.ConvertTo4Bit1Click(Sender: TObject);
{ Convert the bitmap to 4Bit. }
var
  iColor: string;
  iExtension: string;
begin
  Screen.Cursor := crHourGlass;
  try
    iExtension := Lowercase(ExtractFileExt(AFileName));
    if iExtension = '.bmp' then
      ImageEnView1.IO.Params.BMP_HandleTransparency := True;
    ImageEnView1.DeSelect;
    ImageEnView1.IO.Params.BitsPerSample := 4;
    ImageEnView1.IO.Params.SamplesPerPixel := 1;
    if ImageEnView1.HasAlphaChannel then
      ImageEnView1.RemoveAlphaChannel;
    ImageEnView1.Proc.ConvertTo(16);
    ImageEnView1.Update;
    iColor := 'RGB 4-Bit';
    ImageEnView1.BackgroundStyle := iebsSolid;
    ImageEnView1.Background := clWhite;
    StatusBar1.Panels[3].Text := 'RGB 4-Bit ';
    if ImageEnView1.HasAlphaChannel then
      StatusBar1.Panels[4].Text := 'Has AlphaChannel'
    else
      StatusBar1.Panels[4].Text := 'No AlphaChannel';
    ImageEnView1.Bitmap.Modified := True;
    ImageEnView1.ImageChange;
    Undo1.Enabled := ImageEnView1.Proc.CanUndo;
    StatusBar1.Panels[7].Text := iColor;
    if ImageEnView1.HasAlphaChannel then
      StatusBar1.Panels[8].Text := 'Has AlphaChannel'
    else
      StatusBar1.Panels[8].Text := 'No AlphaChannel';
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.ConvertTo8Bit1Click(Sender: TObject);
{ Convert the bitmap to 8Bit. }
var
  iColor: string;
  iExtension: string;
begin
  Screen.Cursor := crHourGlass;
  try
    iExtension := Lowercase(ExtractFileExt(AFileName));
    if iExtension = '.bmp' then
      ImageEnView1.IO.Params.BMP_HandleTransparency := True;
    ImageEnView1.IO.Params.BitsPerSample := 8;
    ImageEnView1.IO.Params.SamplesPerPixel := 1;
    if ImageEnView1.HasAlphaChannel then
      ImageEnView1.RemoveAlphaChannel;
    ImageEnView1.Proc.ConvertTo(256);
    ImageEnView1.Update;
    iColor := 'RGB 8-Bit';
    ImageEnView1.BackgroundStyle := iebsSolid;
    ImageEnView1.Background := clWindow;
    StatusBar1.Panels[3].Text := iColor;
    if ImageEnView1.HasAlphaChannel then
      StatusBar1.Panels[4].Text := 'Has AlphaChannel'
    else
      StatusBar1.Panels[4].Text := 'No AlphaChannel';
    ImageEnView1.Bitmap.Modified := True;
    ImageEnView1.ImageChange;
    Undo1.Enabled := ImageEnView1.Proc.CanUndo;
    StatusBar1.Panels[7].Text := iColor;
    if ImageEnView1.HasAlphaChannel then
      StatusBar1.Panels[8].Text := 'Has AlphaChannel'
    else
      StatusBar1.Panels[8].Text := 'No AlphaChannel';
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.Open1Click(Sender: TObject);
{ Open a image file. }
var
  iFilename: string;
  iFolder: string;
  ilayer: Integer;
  iRGB: TRGB;
begin
  if OpenPictureDialog1.Execute then
  begin
    iFilename := OpenPictureDialog1.FileName;
    if FileExists(iFilename) then
    begin
      AFileName := iFilename;
      iFolder := ExtractFileDir(iFilename);
      if DirectoryExists(iFolder) then
        ALastFolder := iFolder
      else
        ALastFolder := '';
      ImageEnView1.Proc.ClearAllUndo;
      ImageEnView1.Proc.ClearAllRedo;
      ImageEnView1.Clear;
      ImageEnView1.LayersClear;
      ImageEnIO1.LoadFromFile(AFileName);
      Caption := 'GDI And GDIPlus API Drawing- ' + AFileName;
      if Fit1.Down then
      begin
        ImageEnView1.Fit;
        ImageEnView1.AutoFit := True;
      end;
      ilayer := ImageEnView1.LayersAdd;
      ImageEnView1.LayersCurrent := ilayer;
      ImageEnView1.CurrentLayer.name := AnsiString('Layer ' + IntToStr(ilayer));
      iRGB := ImageEnView1.IEBitmap.Pixels[0, ImageEnView1.IEBitmap.Height - 1];
      ImageEnView1.Proc.SetTransparentColors(iRGB, iRGB, 0);
      ImageEnView1.Update;
      DeleteLayer1.Enabled := ImageEnView1.LayersCount > 1;
      MergeLayer1.Enabled := ImageEnView1.LayersCount > 1;
      StatusBar1.Panels[9].Text := 'Layers: ' +
        IntToStr(ImageEnView1.LayersCount);
      ImageEnView1.Update;
      DeleteLayer1.Enabled := ImageEnView1.LayersCount > 1;
      StatusBar1.Panels[0].Text :=
        EllipsifyText(True, ExtractFilePath(AFileName), Canvas,
        StatusBar1.Panels[0].Width);
      StatusBar1.Panels[1].Text := EllipsifyText(False,
        ExtractFilename(AFileName), Canvas, StatusBar1.Panels[1].Width);
      StatusBar1.Panels[2].Text := 'Width: ' +
        IntegerToString(ImageEnView1.IEBitmap.Width);
      StatusBar1.Panels[3].Text := 'Height: ' +
        IntegerToString(ImageEnView1.IEBitmap.Height);
      StatusBar1.Panels[9].Text := 'Layers: ' +
        IntToStr(ImageEnView1.LayersCount);
    end;
  end;
end;

procedure TForm1.PanZoom1Click(Sender: TObject);
begin
  ADrawing := False;
  ImageEnView1.MouseInteract := [miScroll, miZoom];
  Draw1.Down := False;
  Line1.Down := False;
  Fill1.Down := False;
  FillAlpha1.Down := False;
  Rectangle1.Down := False;
  FilledRectangle1.Down := False;
  PickColor1.Down := False;
  RoundRectangle1.Down := False;
  FilledRoundRectangle1.Down := False;
  Ellipse1.Down := False;
  FilledEllipse1.Down := False;
  EnableTouch(True);
end;

procedure TForm1.EnableTouch(AValue: Boolean);
begin
  if AValue then
  begin
    ImageEnView1.Gestures.Pan.Enabled := True;
    ImageEnView1.Gestures.Zoom.Enabled := True;
    ImageEnView1.Gestures.LayerRotate.Enabled := False;
    if not IEHasGestures then
      ShowMessage('Gestures are not enabled.');
  end
  else
  begin
    ImageEnView1.Gestures.Pan.Enabled := False;
    ImageEnView1.Gestures.Zoom.Enabled := False;
    ImageEnView1.Gestures.LayerRotate.Enabled := False;
    ShowMessage('Gestures are not disabled.');
  end;
end;

procedure TForm1.PenAlpha1Change(Sender: TObject);
{ Change the opacity value. }
var
  ios: single;
  iOpacity: Integer;
begin
  if not AOpacityChanging then
  begin
    AAlphaChanging := True;
    ios := IEAlphaToOpacity(StrToInt(PenAlpha1.Text));
    iOpacity := Round(ios);
    PenOpacity1.Text := IntToStr(iOpacity);
    AAlphaChanging := False;
    PenShape1.Brush.Color := DitherColor(PenColor1.Selected,
      StrToInt(PenAlpha1.Text));
  end;
end;

procedure TForm1.PenColor1Change(Sender: TObject);
begin
  PenShape1.Brush.Color := DitherColor(BrushColor1.Selected,
    StrToInt(BrushAlpha1.Text));
  ImageEnView1.Update;
end;

procedure TForm1.PenOpacity1Change(Sender: TObject);
{ Change the alpha value. }
var
  iAlpha: Integer;
  iOpacity: Integer;
begin
  if not AAlphaChanging then
  begin
    AOpacityChanging := True;
    iOpacity := StrToIntDef(PenOpacity1.Text, 255);
    iAlpha := IEOpacityToAlpha(iOpacity);
    PenAlpha1.Text := IntToStr(iAlpha);
    AOpacityChanging := False;
    ImageEnView1.Update;
    PenShape1.Brush.Color := DitherColor(PenColor1.Selected,
      StrToInt(PenAlpha1.Text));
  end;
end;

procedure TForm1.PenSizeScrollBar1Change(Sender: TObject);
begin
  BrushSize1.Text := IntToStr(PenSizeScrollBar1.Position);
end;

procedure TForm1.PenType1Click(Sender: TObject);
begin
  { Refresh the backbuffer }
  ImageEnView1.Update;
end;

procedure TForm1.PickColor1Click(Sender: TObject);
begin
  if PickColor1.Down then
  begin
    ADrawing := False;
    ImageEnView1.Cursor := crPickColor;
    None1.Checked := True;
    ImageEnView1.MouseInteract := [];
  end
  else
    ImageEnView1.Cursor := 1784;
end;

procedure TForm1.Rectangle1Click(Sender: TObject);
begin
  ADrawing := False;
  None1.Checked := True;
  ImageEnView1.MouseInteract := [];
end;

procedure TForm1.RoundRectangle1Click(Sender: TObject);
begin
  ADrawing := False;
  None1.Checked := True;
  ImageEnView1.MouseInteract := [];
end;

procedure TForm1.UpdateUndoHint;
begin
  with ImageEnView1.Proc do
  begin
    Undo1.Enabled := UndoCount > 0;
    if UndoCount > 0 then
      Undo1.Hint := 'Undo ' + UndoCaptions[0];
  end;
end;

procedure TForm1.Cast_Color(BX: Integer; BY: Integer);
{ Cast a color. }
begin
  ImageEnView1.IEBitmap.Canvas.FloodFill(BX, BY, BrushColor1.Selected,
    fsSurface);
  ImageEnView1.IEBitmap.AlphaChannel.Canvas.FloodFill(BX, BY,
    BrushColor1.Selected, fsSurface);
  ImageEnView1.Proc.CastColor(BX, BY, TColor2TRGB(BrushColor1.Selected), 15);
  ImageEnView1.Proc.CastAlpha(BX, BY, StrToInt(BrushAlpha1.Text), 15);
  ImageEnView1.Update;
  Fill1.Down := False;
  ImageEnView1.Bitmap.Modified := True;
  SaveAs1.Enabled := ImageEnView1.Bitmap.Modified;
  ImageEnView1.Cursor := 1784;
end;

procedure TForm1.Cast_Alpha(BX: Integer; BY: Integer);
{ Cast a alpha. }
begin
  ImageEnView1.Proc.CastAlpha(BX, BY, StrToInt(BrushAlpha1.Text),
    StrToInt(FillTolerance1.Text));
  ImageEnView1.Update;
  FillAlpha1.Down := False;
  ImageEnView1.Bitmap.Modified := True;
  SaveAs1.Enabled := ImageEnView1.Bitmap.Modified;
  ImageEnView1.Cursor := 1784;
end;

procedure TForm1.Pick_Color(BY: Integer; BX: Integer);
{ Pick a color. }
begin
  ADrawing := False;
  BrushColor1.Selected := DitherColor(ImageEnView1.IEBitmap.Canvas.Pixels[BX,
    BY], StrToInt(BrushAlpha1.Text));
  if StrToInt(BrushAlpha1.Text) = 255 then
    BrushShape1.Brush.Color := BrushColor1.Selected
  else
    BrushShape1.Brush.Color := DitherColor(BrushColor1.Selected,
      StrToInt(BrushAlpha1.Text));
  PickColor1.Down := False;
  ImageEnView1.Bitmap.Modified := True;
  SaveAs1.Enabled := ImageEnView1.Bitmap.Modified;
  ImageEnView1.Cursor := 1784;
end;

procedure TForm1.Undo1Click(Sender: TObject);
{ Undo the last undo. }
begin
  with ImageEnView1.Proc do
  begin
    Undo;
    ClearUndo;
    UpdateUndoHint;
  end;
  if ImageEnView1.Proc.UndoCount = 0 then
    ImageEnView1.Bitmap.Modified := False;
  ImageEnView1.Bitmap.Modified := ImageEnView1.Proc.UndoCount > 0;
  Save1.Enabled := ImageEnView1.Bitmap.Modified;
  SaveAs1.Enabled := ImageEnView1.Bitmap.Modified;
  StatusBar1.Panels[0].Text := EllipsifyText(True, ExtractFilePath(AFileName),
    Canvas, StatusBar1.Panels[0].Width);
  StatusBar1.Panels[1].Text := EllipsifyText(False, ExtractFilename(AFileName),
    Canvas, StatusBar1.Panels[1].Width);
  StatusBar1.Panels[2].Text := 'Width: ' +
    IntegerToString(ImageEnView1.IEBitmap.Width);
  StatusBar1.Panels[3].Text := 'Height: ' +
    IntegerToString(ImageEnView1.IEBitmap.Height);
end;

procedure TForm1.CenterImage1Click(Sender: TObject);
begin
  ImageEnView1.Center := CenterImage1.Checked;
  ImageEnView1.Update;
end;

procedure TForm1.Fill1Click(Sender: TObject);
begin
  if Fill1.Down then
  begin
    ADrawing := False;
    ImageEnView1.Cursor := crPotOPaint;
    None1.Checked := True;
    ImageEnView1.MouseInteract := [];
  end
  else
    ImageEnView1.Cursor := 1784;
end;

procedure TForm1.FillAlpha1Click(Sender: TObject);
begin
  if FillAlpha1.Down then
  begin
    ADrawing := False;
    ImageEnView1.Cursor := crPotOPaint;
    None1.Checked := True;
    ImageEnView1.MouseInteract := [];
  end
  else
    ImageEnView1.Cursor := 1784;
end;

procedure TForm1.FilledEllipse1Click(Sender: TObject);
begin
  ADrawing := False;
  None1.Checked := True;
  ImageEnView1.MouseInteract := [];
end;

procedure TForm1.FilledRectangle1Click(Sender: TObject);
begin
  ADrawing := False;
  None1.Checked := True;
  ImageEnView1.MouseInteract := [];
end;

procedure TForm1.FilledRoundRectangle1Click(Sender: TObject);
begin
  ADrawing := False;
  None1.Checked := True;
  ImageEnView1.MouseInteract := [];
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  iDocumentsFolder: string;
  iColor: string;
begin
  AFileName := '';
  IERegisterFormats;
  OpenPictureDialog1.Filter := GraphicFilter(TGraphic);
  SavePictureDialog1.Filter := GraphicFilter(TGraphic);
  ImageEnView1.SetChessboardStyle(8);
  ImageEnView1.Blank;
  Screen.Cursors[crPotOPaint] := LoadCursor(HInstance, 'CRPOTOPAINT');
  Screen.Cursors[crPickColor] := LoadCursor(HInstance, 'CRPICKCOLOR');
  ImageEnView1.SelectionBase := iesbBitmap;
  ImageEnView1.SelectionMaskDepth := 8;
  ImageEnView1.SelectionIntensity := 255;
  UseGDIPlus1.Checked := IEGDIPEnabled;
  ImageEnView1.LegacyBitmap := True;
  iDocumentsFolder := DocumentsFolder;
  AFileName := iDocumentsFolder + '\untitled.bmp';
  ImageEnView1.IO.Params.FileName := AFileName;
  ImageEnView1.IO.Params.BMP_HandleTransparency := True;
  ImageEnView1.Gestures.Pan.Enabled := True;
  ImageEnView1.Gestures.Zoom.Enabled := True;
  Caption := 'GDI And GDIPlus API Drawing- ' + AFileName;
  ScrollBox1.VertScrollBar.Position := 0;
  if not IEGDIPAvailable then
  begin
    MessageBeep(MB_ICONWARNING);
    TaskDialog1.MainIcon := tdiWarning;
    TaskDialog1.Title := 'Error';
    TaskDialog1.Caption := 'GDIPlus Is Not Installed';
    TaskDialog1.Text := 'GDIPlus is not available.';
    TaskDialog1.CommonButtons := [tcbOk];
    TaskDialog1.Execute;
  end
  else
  begin
    if UseGDIPlus1.Checked then
      IEGDIPLoadLibrary
    else
      IEGDIPUnLoadLibrary;
  end;

  AIniFilename := IncludeTrailingBackSlash(AppDataFolder) +
    'ASG\GDIPlusImageMaker\' + 'GDIPlusImageMaker.ini';
  ForceDirectories(IncludeTrailingBackSlash(AppDataFolder) +
    'ASG\GDIPlusImageMaker');
  ReadIni(AIniFilename);

  StatusBar1.Panels[0].Text := EllipsifyText(True, ExtractFilePath(AFileName),
    Canvas, StatusBar1.Panels[0].Width);
  StatusBar1.Panels[1].Text := EllipsifyText(False, ExtractFilename(AFileName),
    Canvas, StatusBar1.Panels[1].Width);
  StatusBar1.Panels[2].Text := 'Width: ' +
    IntegerToString(ImageEnView1.IEBitmap.Width);
  StatusBar1.Panels[3].Text := 'Height: ' +
    IntegerToString(ImageEnView1.IEBitmap.Height);
  StatusBar1.Panels[7].Text := iColor;
  if ImageEnView1.HasAlphaChannel then
    StatusBar1.Panels[8].Text := 'Has AlphaChannel'
  else
    StatusBar1.Panels[8].Text := 'No AlphaChannel';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  WriteIni(AIniFilename);
  IEUnregisterFormats;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = vk_Escape then
    Close;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  ImageEnView1.Proc.AutoUndo := False;
  ImageEnView1.Layers[0].Selectable := True;
  ImageEnView1.Layers[0].VisibleBox := False;
  ImageEnView1.Layers[0].Locked := True;
  ImageEnView1.Layers[0].name := 'Main';
  ImageEnView1.LayersCurrent := 0;
  ImageEnView1.Update;
  ImageEnView1.Proc.ClearAllUndo;
  ImageEnView1.Proc.ClearAllRedo;
  ImageEnView1.Proc.ClearUndo;
  ImageEnView1.Proc.UndoLimit := 99;
  AZoom := ImageEnView1.Zoom;
  Undo1.Enabled := False;
  ImageEnView1.Bitmap.Modified := False;
  SaveAs1.Enabled := False;
  ImageEnView1.LayersSync := True;
  { Post the custom message WM_AFTER_SHOW to our form }
  PostMessage(Self.Handle, WM_AFTER_SHOW, 0, 0);
end;

procedure TForm1.WmAfterShow(var Msg: TMessage);
{ This event is executed after OnShow. }
var
  ilayer: Integer;
  iRGB: TRGB;
  iColor: string;
begin
  ImageEnView1.IEBitmap.Allocate(ImageEnView1.ClientWidth,
    ImageEnView1.ClientHeight);
  ImageEnView1.IEBitmap.Fill(clWhite);
  ImageEnView1.IO.Params.BitsPerSample := 8;
  ImageEnView1.IO.Params.SamplesPerPixel := 3;
  iColor := 'RGBA 24-Bit';
  ImageEnView1.BackgroundStyle := iebsChessboard;
  ImageEnView1.Background := clBtnFace;
  ImageEnView1.HasAlphaChannel;
  ImageEnView1.Bitmap.Modified := False;
  Undo1.Enabled := ImageEnView1.Proc.CanUndo;
  ImageEnView1.Proc.AutoUndo := False;
  ImageEnView1.Proc.UndoLimit := 99;
  ImageEnView1.Background := Vcl.Themes.TStyleManager.ActiveStyle.GetSystemColor
    (clBtnFace);
  ImageEnView1.Gestures.Pan.Enabled := True;
  ImageEnView1.Gestures.Zoom.Enabled := True;
  if not IEHasGestures then
    ShowMessage('Gestures are not enabled.');
  ilayer := ImageEnView1.LayersAdd;
  ImageEnView1.LayersCurrent := ilayer;
  ImageEnView1.CurrentLayer.name := AnsiString('Layer ' + IntToStr(ilayer));
  iRGB := ImageEnView1.IEBitmap.Pixels[0, ImageEnView1.IEBitmap.Height - 1];
  ImageEnView1.Proc.SetTransparentColors(iRGB, iRGB, 0);
  ImageEnView1.Update;
  DeleteLayer1.Enabled := ImageEnView1.LayersCount > 1;
  MergeLayer1.Enabled := ImageEnView1.LayersCount > 1;
  StatusBar1.Panels[9].Text := 'Layers: ' + IntToStr(ImageEnView1.LayersCount);
end;

procedure TForm1.Fit1Click(Sender: TObject);
begin
  if Fit1.Down then
  begin
    ImageEnView1.AutoFit := True;
    ImageEnView1.Fit;
    Fit1.Caption := IntegerToString(Round(ImageEnView1.Zoom)) + '%';
    ImageEnView1.Zoom := ImageEnView1.GetIdealZoom;
  end
  else
  begin
    ImageEnView1.AutoFit := False;
    ImageEnView1.Zoom := 100;
    Fit1.Caption := '100%';
  end;
end;

procedure TForm1.Grid1Click(Sender: TObject);
begin
  ImageEnView1.DisplayGrid := Grid1.Checked;
end;

procedure TForm1.DeleteLayer1Click(Sender: TObject);
var
  iSelectedLayer: Integer;
begin
  iSelectedLayer := ImageEnView1.LayersCurrent;
  if iSelectedLayer > 0 then
    ImageEnView1.LayersRemove(iSelectedLayer);
  ImageEnView1.Update;
  DeleteLayer1.Enabled := ImageEnView1.LayersCount > 1;
  MergeLayer1.Enabled := ImageEnView1.LayersCount > 1;
  StatusBar1.Panels[9].Text := 'Layers: ' + IntToStr(ImageEnView1.LayersCount);
end;

procedure TForm1.Draw1Click(Sender: TObject);
begin
  if Draw1.Down then
  begin
    ADrawing := True;
    None1.Checked := True;
    ImageEnView1.MouseInteract := [];
  end
  else
    ADrawing := False;
  ImageEnView1.Update;
end;

procedure TForm1.Ellipse1Click(Sender: TObject);
begin
  ADrawing := False;
  None1.Checked := True;
  ImageEnView1.MouseInteract := [];
end;

procedure TForm1.Erase1Click(Sender: TObject);
begin
  if ImageEnView1.LayersCount > 1 then
  begin
    if Erase1.Down then
    begin
      ADrawing := True;
      None1.Checked := True;
      ImageEnView1.MouseInteract := [];
    end
    else
    begin
      ADrawing := False;
    end;
    ImageEnView1.Update;
  end
  else
  begin
    MessageDlg('The image must have at least 1 layer to erase.', mtWarning,
      [mbOK], 0);
    Erase1.Down := False;
  end;
end;

procedure TForm1.DrawBrush(X: Integer; Y: Integer);
{ Draw a brush. }
var
  iIECanvas1: TIECanvas;
  iIECanvas2: TIECanvas;
  iBrushWidth: Integer;
  iBrushcolor: TColor;
  iBrushAlpha: Integer;
begin
  { Draw on the Non-Alpha Canvas }
  iIECanvas1 := TIECanvas.Create(ImageEnView1.Layers[ImageEnView1.LayersCurrent]
    .Bitmap.Canvas, AntiAlias1.Checked, UseGDIPlus1.Checked);
  iBrushWidth := StrToInt(BrushSize1.Text);
  iBrushcolor := BrushColor1.Selected;
  iBrushAlpha := StrToInt(BrushAlpha1.Text);
  iIECanvas1.Pen.Style := psClear;
  iIECanvas1.Brush.Color := iBrushcolor;
  iIECanvas1.Brush.Style := bsSolid;
  iIECanvas1.Brush.Transparency := iBrushAlpha;
  iIECanvas1.Brush.BackTransparency := iBrushAlpha;
  if PenType1.ItemIndex = 0 then
    iIECanvas1.Ellipse(X - iBrushWidth, Y - iBrushWidth, X + iBrushWidth,
      Y + iBrushWidth)
  else
    iIECanvas1.Rectangle(X - iBrushWidth, Y - iBrushWidth, X + iBrushWidth,
      Y + iBrushWidth);
  iIECanvas1.Free();
  { Draw on the Alpha Canvas }
  iIECanvas2 := ImageEnView1.Layers[ImageEnView1.LayersCurrent]
    .Bitmap.AlphaChannel.CreateROICanvas(Rect(X - iBrushWidth, Y - iBrushWidth,
    X + iBrushWidth, Y + iBrushWidth), AntiAlias1.Checked, True);
  iIECanvas2.Pen.Style := psClear;
  iIECanvas2.Pen.Color := iBrushAlpha or (iBrushAlpha shl 8) or
    (iBrushAlpha shl 16);
  iIECanvas2.Brush.Style := bsSolid;
  iIECanvas2.Brush.Color := iBrushAlpha or (iBrushAlpha shl 8) or
    (iBrushAlpha shl 16);
  if PenType1.ItemIndex = 0 then
    iIECanvas2.Ellipse(Rect(X - iBrushWidth, Y - iBrushWidth, X + iBrushWidth,
      Y + iBrushWidth))
  else
    iIECanvas1.Rectangle(X - iBrushWidth, Y - iBrushWidth, X + iBrushWidth,
      Y + iBrushWidth);
  iIECanvas2.Free();
  ImageEnView1.Bitmap.Modified := True;
end;

procedure TForm1.EraseBrush(X: Integer; Y: Integer);
{ Draw a brush }
var
  iIECanvas1: TIECanvas;
  iIECanvas2: TIECanvas;
  iBrushWidth: Integer;
  iBrushAlpha: Integer;
begin
  { Draw on the Non-Alpha Canvas }
  iIECanvas1 := TIECanvas.Create(ImageEnView1.Layers[ImageEnView1.LayersCurrent]
    .Bitmap.Canvas, AntiAlias1.Checked, UseGDIPlus1.Checked);
  iBrushWidth := StrToInt(BrushSize1.Text);
  iBrushAlpha := 0;
  iIECanvas1.Pen.Style := psClear;
  iIECanvas1.Brush.Style := bsSolid;
  iIECanvas1.Brush.Transparency := 0;
  iIECanvas1.Brush.BackTransparency := 0;
  if PenType1.ItemIndex = 0 then
    iIECanvas1.Ellipse(X - iBrushWidth, Y - iBrushWidth, X + iBrushWidth,
      Y + iBrushWidth)
  else
    iIECanvas1.Rectangle(X - iBrushWidth, Y - iBrushWidth, X + iBrushWidth,
      Y + iBrushWidth);
  iIECanvas1.Free();
  { Draw on the Alpha Canvas }
  iIECanvas2 := ImageEnView1.Layers[ImageEnView1.LayersCurrent]
    .Bitmap.AlphaChannel.CreateROICanvas(Rect(X - iBrushWidth, Y - iBrushWidth,
    X + iBrushWidth, Y + iBrushWidth), AntiAlias1.Checked, True);
  iIECanvas2.Pen.Style := psClear;
  iIECanvas2.Brush.Style := bsSolid;
  iIECanvas2.Brush.Color := iBrushAlpha or (iBrushAlpha shl 8) or
    (iBrushAlpha shl 16);
  if PenType1.ItemIndex = 0 then
    iIECanvas2.Ellipse(Rect(X - iBrushWidth, Y - iBrushWidth, X + iBrushWidth,
      Y + iBrushWidth))
  else
    iIECanvas1.Rectangle(X - iBrushWidth, Y - iBrushWidth, X + iBrushWidth,
      Y + iBrushWidth);
  iIECanvas2.Free();
  ImageEnView1.Bitmap.Modified := True;
end;

procedure TForm1.DrawLine;
{ Draw a line. }
var
  iPenSize: Integer;
  iBrushcolor: TColor;
  iBrushAlpha: Integer;
begin
  ADrawing := False;
  MyUndo(ImageEnView1);
  { Draw on the Non-Alpha Canvas }
  ANewCanvas := TIECanvas.Create(ImageEnView1.IEBitmap.Canvas,
    AntiAlias1.Checked, UseGDIPlus1.Checked);
  iPenSize := StrToInt(BrushSize1.Text);
  iBrushcolor := BrushColor1.Selected;
  iBrushAlpha := StrToInt(BrushAlpha1.Text);
  ANewCanvas.Pen.Color := iBrushcolor;
  ANewCanvas.Pen.Style := psSolid;
  ANewCanvas.Pen.Width := iPenSize;
  ANewCanvas.Brush.Color := iBrushcolor;
  ANewCanvas.Brush.BackColor := iBrushcolor;
  ANewCanvas.Brush.Style := bsSolid;
  ANewCanvas.Brush.Transparency := iBrushAlpha;
  ANewCanvas.Brush.BackTransparency := iBrushAlpha;
  ANewCanvas.MoveTo(AStartX, AStartY);
  ANewCanvas.LineTo(APX, APY);
  ANewCanvas.LineTo(AStartX, AStartY);
  ANewCanvas.Free();
  { Draw on the Alpha Canvas - do not assign color here... it will overwrite
    the alphachannel }
  ImageEnView1.IEBitmap.AlphaChannel.CanvasCurrentAlpha := iBrushAlpha;
  ANewCanvas := TIECanvas.Create(ImageEnView1.IEBitmap.AlphaChannel.Canvas,
    AntiAlias1.Checked, UseGDIPlus1.Checked);
  ANewCanvas.Pen.Width := iPenSize;
  ANewCanvas.Pen.Style := psSolid;
  ANewCanvas.Pen.Transparency := iBrushAlpha;
  ANewCanvas.Brush.Style := bsSolid;
  ANewCanvas.Brush.Transparency := iBrushAlpha;
  ANewCanvas.Brush.BackTransparency := iBrushAlpha;
  ANewCanvas.MoveTo(AStartX, AStartY);
  ANewCanvas.LineTo(APX, APY);
  ANewCanvas.LineTo(AStartX, AStartY);
  ANewCanvas.Free();
  ImageEnView1.Bitmap.Modified := True;
end;

procedure TForm1.DrawRectangle;
{ Draw a rectangle. }
var
  iPenSize: Integer;
  iPenColor: TColor;
  iPenAlpha: Integer;
  iBrushcolor: TColor;
  iBrushAlpha: Integer;
begin
  MyUndo(ImageEnView1);
  { Draw on the Non-Alpha Canvas }
  ANewCanvas := TIECanvas.Create(ImageEnView1.IEBitmap.Canvas,
    AntiAlias1.Checked, UseGDIPlus1.Checked);
  iPenSize := StrToInt(BrushSize1.Text);
  iPenColor := PenColor1.Selected;
  iPenAlpha := StrToInt(PenAlpha1.Text);
  iBrushcolor := BrushColor1.Selected;
  iBrushAlpha := StrToInt(BrushAlpha1.Text);
  ANewCanvas.Pen.LineJoin := ieljMiter;
  ANewCanvas.Pen.Color := iPenColor;
  ANewCanvas.Pen.Transparency := iPenAlpha;
  ANewCanvas.Pen.Style := psSolid;
  ANewCanvas.Pen.Width := iPenSize;
  ANewCanvas.Brush.Color := iBrushcolor;
  ANewCanvas.Brush.BackColor := iBrushcolor;
  ANewCanvas.Brush.Style := bsClear;
  ANewCanvas.Brush.Transparency := iBrushAlpha;
  ANewCanvas.Brush.BackTransparency := iBrushAlpha;
  ANewCanvas.Rectangle(AStartX, AStartY, APX + iPenSize, APY + iPenSize);
  ANewCanvas.Free();
  { Draw on the Alpha Canvas }
  ImageEnView1.IEBitmap.AlphaChannel.CanvasCurrentAlpha := iPenAlpha;
  ANewCanvas := TIECanvas.Create(ImageEnView1.IEBitmap.AlphaChannel.Canvas,
    AntiAlias1.Checked, UseGDIPlus1.Checked);
  ANewCanvas.Pen.LineJoin := ieljMiter;
  ANewCanvas.Pen.Width := iPenSize;
  ANewCanvas.Pen.Style := psSolid;
  ANewCanvas.Pen.Transparency := iPenAlpha;
  ANewCanvas.Brush.Style := bsClear;
  ANewCanvas.Brush.Transparency := iBrushAlpha;
  ANewCanvas.Brush.BackTransparency := iBrushAlpha;
  ANewCanvas.Rectangle(AStartX, AStartY, APX + iPenSize, APY + iPenSize);
  ANewCanvas.Free();
  ImageEnView1.Bitmap.Modified := True;
end;

procedure TForm1.DrawFilledRectangle;
{ Draw a filled rectangle. }
var
  iPenSize: Integer;
  iPenColor: TColor;
  iPenAlpha: Integer;
  iBrushcolor: TColor;
  iBrushAlpha: Integer;
begin
  MyUndo(ImageEnView1);
  { Draw on the Non-Alpha Canvas }
  ANewCanvas := TIECanvas.Create(ImageEnView1.IEBitmap.Canvas,
    AntiAlias1.Checked, UseGDIPlus1.Checked);
  iPenSize := StrToInt(BrushSize1.Text);
  iPenColor := PenColor1.Selected;
  iPenAlpha := StrToInt(PenAlpha1.Text);
  iBrushcolor := BrushColor1.Selected;
  iBrushAlpha := StrToInt(BrushAlpha1.Text);
  ANewCanvas.Pen.LineJoin := ieljMiter;
  ANewCanvas.Pen.Color := iPenColor;
  ANewCanvas.Pen.Transparency := iPenAlpha;
  ANewCanvas.Pen.Style := psSolid;
  ANewCanvas.Pen.Width := iPenSize;
  ANewCanvas.Brush.Color := iBrushcolor;
  ANewCanvas.Brush.BackColor := iBrushcolor;
  ANewCanvas.Brush.Style := bsSolid;
  ANewCanvas.Brush.Transparency := iBrushAlpha;
  ANewCanvas.Brush.BackTransparency := iBrushAlpha;
  ANewCanvas.Rectangle(AStartX, AStartY, APX + iPenSize, APY + iPenSize);
  ANewCanvas.Free();
  { Draw on the Alpha Canvas }
  ImageEnView1.IEBitmap.AlphaChannel.CanvasCurrentAlpha := iPenAlpha;
  ANewCanvas := TIECanvas.Create(ImageEnView1.IEBitmap.AlphaChannel.Canvas,
    AntiAlias1.Checked, UseGDIPlus1.Checked);
  ANewCanvas.Pen.LineJoin := ieljMiter;
  ANewCanvas.Pen.Width := iPenSize;
  ANewCanvas.Pen.Style := psSolid;
  ANewCanvas.Pen.Transparency := iPenAlpha;
  ANewCanvas.Brush.Style := bsSolid;
  ANewCanvas.Brush.Transparency := iBrushAlpha;
  ANewCanvas.Brush.BackTransparency := iBrushAlpha;
  ANewCanvas.Rectangle(AStartX, AStartY, APX + iPenSize, APY + iPenSize);
  ANewCanvas.Free();
  ImageEnView1.Bitmap.Modified := True;
end;

procedure TForm1.DrawRoundRectangle;
{ Draw a round rectangle. }
var
  iPenSize: Integer;
  iPenColor: TColor;
  iPenAlpha: Integer;
  iBrushcolor: TColor;
  iBrushAlpha: Integer;
  iRoundRectRadius: Integer;
  iIECanvas1: TIECanvas;
  iIECanvas2: TIECanvas;
  ix1, iy1, ix2, iy2: Integer;
begin
  ImageEnView1.Proc.Undo;
  { Draw on the Non-Alpha Canvas }
  iIECanvas1 := TIECanvas.Create(ImageEnView1.IEBitmap.Canvas,
    AntiAlias1.Checked, UseGDIPlus1.Checked);
  iPenSize := StrToInt(BrushSize1.Text);
  iPenColor := PenColor1.Selected;
  iPenAlpha := StrToInt(PenAlpha1.Text);
  iBrushcolor := BrushColor1.Selected;
  iBrushAlpha := StrToInt(BrushAlpha1.Text);
  iRoundRectRadius := StrToInt(RoundRectRadius1.Text);
  iIECanvas1.Pen.Style := psSolid;
  iIECanvas1.Pen.Transparency := iPenAlpha;
  iIECanvas1.Pen.Color := iPenColor;
  iIECanvas1.Pen.Width := iPenSize;
  iIECanvas1.Brush.Style := bsClear;
  iIECanvas1.Brush.Transparency := iBrushAlpha;
  iIECanvas1.Brush.Color := iBrushcolor;
  iIECanvas1.Brush.BackColor := iBrushcolor;
  iIECanvas1.Brush.BackTransparency := iBrushAlpha;
  ix1 := AStartX - iPenSize;
  iy1 := AStartY - iPenSize;
  ix2 := ALastX + iPenSize;
  iy2 := ALastY + iPenSize;
  iIECanvas1.RoundRect(ix1, iy1, ix2, iy2, iRoundRectRadius, iRoundRectRadius);
  iIECanvas1.Free();
  { Draw on the Alpha Canvas }
  OrdCor(ix1, iy1, ix2, iy2);
  iIECanvas2 := ImageEnView1.Layers[ImageEnView1.LayersCurrent]
    .Bitmap.AlphaChannel.CreateROICanvas(Rect(ix1 - iPenSize, iy1 - iPenSize,
    ix2 + iPenSize, iy2 + iPenSize), AntiAlias1.Checked, UseGDIPlus1.Checked);
  iIECanvas2.Pen.Style := psSolid;
  iIECanvas2.Pen.Transparency := iPenAlpha;
  iIECanvas2.Pen.Color := iPenAlpha or (iPenAlpha shl 8) or (iPenAlpha shl 16);
  iIECanvas2.Pen.Width := iPenSize;
  iIECanvas2.Brush.Style := bsClear;
  iIECanvas2.Brush.Transparency := iBrushAlpha;
  iIECanvas2.Brush.Color := iBrushAlpha or (iBrushAlpha shl 8) or
    (iBrushAlpha shl 16);
  iIECanvas2.RoundRect(ix1, iy1, ix2, iy2, iRoundRectRadius, iRoundRectRadius);
  ImageEnView1.Bitmap.Modified := True;
  iIECanvas2.Free();
end;

procedure TForm1.DrawFilledRoundRectangle;
{ Draw a filled round rectangle. }
var
  iPenSize: Integer;
  iPenColor: TColor;
  iPenAlpha: Integer;
  iBrushcolor: TColor;
  iBrushAlpha: Integer;
  iRoundRectRadius: Integer;
  iIECanvas1: TIECanvas;
  iIECanvas2: TIECanvas;
  ix1, iy1, ix2, iy2: Integer;
begin
  ImageEnView1.Proc.Undo;
  { Draw on the Non-Alpha Canvas }
  iIECanvas1 := TIECanvas.Create(ImageEnView1.IEBitmap.Canvas,
    AntiAlias1.Checked, UseGDIPlus1.Checked);
  iPenSize := StrToInt(BrushSize1.Text);
  iPenColor := PenColor1.Selected;
  iPenAlpha := StrToInt(PenAlpha1.Text);
  iBrushcolor := BrushColor1.Selected;
  iBrushAlpha := StrToInt(BrushAlpha1.Text);
  iRoundRectRadius := StrToIntDef(RoundRectRadius1.Text, 4);
  iIECanvas1.Pen.Color := iPenColor;
  iIECanvas1.Pen.Transparency := iPenAlpha;
  iIECanvas1.Pen.Style := psSolid;
  iIECanvas1.Pen.Width := iPenSize;
  iIECanvas1.Brush.Color := iBrushcolor;
  iIECanvas1.Brush.BackColor := iBrushcolor;
  iIECanvas1.Brush.Style := bsSolid;
  iIECanvas1.Brush.Transparency := iBrushAlpha;
  iIECanvas1.Brush.BackTransparency := iBrushAlpha;
  ix1 := AStartX - iPenSize;
  iy1 := AStartY - iPenSize;
  ix2 := ALastX + iPenSize;
  iy2 := ALastY + iPenSize;
  iIECanvas1.RoundRect(ix1, iy1, ix2, iy2, iRoundRectRadius, iRoundRectRadius);
  iIECanvas1.Free();
  { Draw on the Alpha Canvas }
  OrdCor(ix1, iy1, ix2, iy2);
  iIECanvas2 := ImageEnView1.Layers[ImageEnView1.LayersCurrent]
    .Bitmap.AlphaChannel.CreateROICanvas(Rect(ix1 - iPenSize, iy1 - iPenSize,
    ix2 + iPenSize, iy2 + iPenSize), AntiAlias1.Checked, UseGDIPlus1.Checked);
  iIECanvas2.Pen.Style := psSolid;
  iIECanvas2.Pen.Color := iPenAlpha or (iPenAlpha shl 8) or (iPenAlpha shl 16);
  iIECanvas2.Pen.Width := iPenSize;
  iIECanvas2.Brush.Style := bsSolid;
  iIECanvas2.Brush.Color := iBrushAlpha or (iBrushAlpha shl 8) or
    (iBrushAlpha shl 16);
  iIECanvas2.RoundRect(ix1, iy1, ix2, iy2, iRoundRectRadius, iRoundRectRadius);
  ImageEnView1.Bitmap.Modified := True;
  iIECanvas2.Free();
end;

procedure TForm1.DrawEllipse;
{ Draw a ellipse. }
var
  iPenSize: Integer;
  iPenColor: TColor;
  iPenAlpha: Integer;
begin
  MyUndo(ImageEnView1);
  { Draw on the Non-Alpha Canvas }
  ANewCanvas := TIECanvas.Create(ImageEnView1.IEBitmap.Canvas);
  iPenSize := StrToInt(BrushSize1.Text);
  iPenColor := PenColor1.Selected;
  iPenAlpha := StrToInt(PenAlpha1.Text);
  ANewCanvas.Pen.Color := iPenColor;
  ANewCanvas.Pen.Style := psSolid;
  ANewCanvas.Pen.Width := iPenSize;
  ANewCanvas.Brush.Color := iPenColor;
  ANewCanvas.Brush.BackColor := iPenColor;
  ANewCanvas.Brush.Style := bsClear;
  ANewCanvas.Brush.Transparency := iPenAlpha;
  ANewCanvas.Brush.BackTransparency := iPenAlpha;
  ANewCanvas.Ellipse(AStartX, AStartY, APX + iPenSize, APY + iPenSize);
  ANewCanvas.Free();
  { Draw on the Alpha Canvas }
  ImageEnView1.IEBitmap.AlphaChannel.CanvasCurrentAlpha := iPenAlpha;
  ANewCanvas := TIECanvas.Create(ImageEnView1.IEBitmap.AlphaChannel.Canvas);
  ANewCanvas.Pen.Width := iPenSize;
  ANewCanvas.Pen.Style := psSolid;
  ANewCanvas.Brush.Style := bsClear;
  ANewCanvas.Brush.Transparency := iPenAlpha;
  ANewCanvas.Brush.BackTransparency := iPenAlpha;
  ANewCanvas.Ellipse(AStartX, AStartY, APX + iPenSize, APY + iPenSize);
  ANewCanvas.Free();
  ImageEnView1.Bitmap.Modified := True;
end;

procedure TForm1.DrawFilledEllipse;
{ Draw a filled ellipse. }
var
  iPenSize: Integer;
  iPenColor: TColor;
  iPenAlpha: Integer;
  iBrushcolor: TColor;
  iBrushAlpha: Integer;
begin
  MyUndo(ImageEnView1);
  { Draw on the Non-Alpha Canvas }
  ANewCanvas := TIECanvas.Create(ImageEnView1.IEBitmap.Canvas);
  iPenSize := StrToInt(BrushSize1.Text);
  iPenColor := PenColor1.Selected;
  iPenAlpha := StrToInt(PenAlpha1.Text);
  iBrushcolor := BrushColor1.Selected;
  iBrushAlpha := StrToInt(BrushAlpha1.Text);
  ANewCanvas.Pen.Color := iPenColor;
  ANewCanvas.Pen.Style := psSolid;
  ANewCanvas.Pen.Width := iPenSize;
  ANewCanvas.Brush.Color := iBrushcolor;
  ANewCanvas.Brush.BackColor := iBrushcolor;
  ANewCanvas.Brush.Style := bsSolid;
  ANewCanvas.Brush.Transparency := iBrushAlpha;
  ANewCanvas.Brush.BackTransparency := iBrushAlpha;
  ANewCanvas.Ellipse(AStartX, AStartY, APX + iPenSize, APY + iPenSize);
  ANewCanvas.Free();
  { Draw on the Alpha Canvas }
  ImageEnView1.IEBitmap.AlphaChannel.CanvasCurrentAlpha := iPenAlpha;
  ANewCanvas := TIECanvas.Create(ImageEnView1.IEBitmap.AlphaChannel.Canvas);
  ANewCanvas.Pen.Width := iPenSize;
  ANewCanvas.Pen.Style := psSolid;
  ANewCanvas.Brush.Style := bsSolid;
  ANewCanvas.Brush.Transparency := iBrushAlpha;
  ANewCanvas.Brush.BackTransparency := iBrushAlpha;
  ANewCanvas.Ellipse(AStartX, AStartY, APX + iPenSize, APY + iPenSize);
  ANewCanvas.Free();
  ImageEnView1.Bitmap.Modified := True;
end;

procedure TForm1.ImageEnView1MouseLeave(Sender: TObject);
{ Remove the backbuffer drawing if cursor is not in the component. }
begin
  if (not Draw1.Down) or not(Erase1.Down) then
  begin
    ADrawing := False;
    { Turn off the backbuffer drawing }
    ImageEnView1.OnDrawBackBuffer := nil;
    ImageEnView1.Update;
  end;
  if (Draw1.Down) and (StrToInt(BrushSize1.Text) = 1) then
    ImageEnView1.HighlightedPixel := Point(-1, -1);
  if (Draw1.Down) and (StrToInt(BrushSize1.Text) > 1) then
  begin
    { Turn off the backbuffer drawing }
    ImageEnView1.OnDrawBackBuffer := nil;
    ImageEnView1.Update;
  end;
end;

procedure TForm1.ImageEnView1DrawBackBuffer(Sender: TObject);
{ Draw the backbuffer - The drawing cursor is created here. }
var
  i: double;
  x1, y1, x2, y2: Integer;
  z: double;
begin
  if (StrToInt(BrushSize1.Text) > 1) and (ADrawing) then
  begin
    with ImageEnView1.BackBuffer.Canvas do
    begin
      i := StrToInt(BrushSize1.Text);
      Pen.Mode := pmCopy;
      Pen.Color := clBlack;
      Brush.Style := bsClear;
      z := ImageEnView1.Zoom / 100;
      x1 := Round(AMX - i * z);
      y1 := Round(AMY - i * z);
      x2 := Round(AMX + i * z);
      y2 := Round(AMY + i * z);
      case PenType1.ItemIndex of
        0:
          Ellipse(x1, y1, x2, y2);
        1:
          Rectangle(x1, y1, x2, y2);
      end;
    end;
  end;
end;

procedure TForm1.ImageEnView1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  BX, BY: Integer;
  iTransparency: Integer;
begin
  { If scrolling or selecting then exit }
  if (ImageEnView1.MouseInteract = [miScroll]) or
    (ImageEnView1.MouseInteract = [miSelect]) then
    exit;
  BX := ImageEnView1.XScr2Bmp(X);
  BY := ImageEnView1.YScr2Bmp(Y);
  AStartX := ImageEnView1.XScr2Bmp(X);
  AStartY := ImageEnView1.YScr2Bmp(Y);
  APX := AStartX;
  APY := AStartY;
  { These public vars are used in DrawBackBuffer }
  if (Draw1.Down) and (StrToInt(BrushSize1.Text) > 1) and ((Shift = [ssLeft]))
  and (ImageEnView1.MouseCapture) then
  begin
    { Draw a brush }
    ImageEnView1.Proc.SaveUndoCaptioned
      ('Draw ' + IntToStr(ImageEnView1.Proc.UndoCount + 1));
    Undo1.Hint := 'Draw ' + IntToStr(ImageEnView1.Proc.UndoCount);
    ADrawing := True;
    DrawBrush(BX, BY);
    ImageEnView1.Update;
  end
  else if (Draw1.Down) and (StrToInt(BrushSize1.Text) = 1) and (
     ImageEnView1.MouseCapture) and
    ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or (Shift = [ssTouch]))
  then
  { TIECanvas can not paint a single point so we paint it on the IEBitmap canvas
    here }
  begin
    { Paint point or 1 pixel }
    with ImageEnView1 do
    begin
      Proc.SaveUndo(ieuImage);
      Undo1.Hint := 'Paint ' + IntToStr(Proc.UndoCount + 1);
      IEBitmap.Canvas.Pen.Color := PenColor1.Selected;
      IEBitmap.Canvas.Pen.Width := StrToInt(BrushSize1.Text);
      IEBitmap.Canvas.Pixels[BX, BY] := PenColor1.Selected;
      iTransparency := StrToInt(PenAlpha1.Text);
      IEBitmap.CanvasCurrentAlpha := StrToInt(PenAlpha1.Text);
      IEBitmap.AlphaChannel.Canvas.Pen.Color := $02000000 or (iTransparency) or
        (iTransparency shl 8) or (iTransparency shl 16);
      IEBitmap.AlphaChannel.Canvas.Pen.Width := StrToInt(BrushSize1.Text);
      IEBitmap.AlphaChannel.Canvas.Pixels[BX, BY] := PenColor1.Selected;
      IEBitmap.Alpha[BX, BY] := iTransparency;
      Update;
    end;
    with ImageEnView1 do
    begin
      IEBitmap.Canvas.Pen.Color := PenColor1.Selected;
      IEBitmap.Canvas.Pen.Width := StrToInt(BrushSize1.Text);
      IEBitmap.Canvas.Pixels[BX, BY] := PenColor1.Selected;
      iTransparency := StrToInt(PenAlpha1.Text);
      IEBitmap.CanvasCurrentAlpha := StrToInt(PenAlpha1.Text);
      IEBitmap.AlphaChannel.Canvas.Pen.Color := $02000000 or (iTransparency) or
        (iTransparency shl 8) or (iTransparency shl 16);
      IEBitmap.AlphaChannel.Canvas.Pen.Width := StrToInt(BrushSize1.Text);
      IEBitmap.AlphaChannel.Canvas.Pixels[BX, BY] := PenColor1.Selected;
      IEBitmap.Alpha[BX, BY] := iTransparency;
      Update;
      Bitmap.Modified := True;
    end;
  end
  else if (Erase1.Down) and (StrToInt(BrushSize1.Text) = 1) and
    ((Shift = [ssLeft]) or (Shift = [ssTouch]) or (Shift = [ssTouch])) then
  { TIECanvas can not paint a single point so we paint it on the IEBitmap canvas
    here }
  begin
    { Paint point or 1 pixel }
    with ImageEnView1 do
    begin
      Proc.SaveUndo(ieuImage);
      Undo1.Hint := 'Erase ' + IntToStr(Proc.UndoCount + 1);
      IEBitmap.Canvas.Pen.Width := StrToInt(BrushSize1.Text);
      iTransparency := 0;
      IEBitmap.CanvasCurrentAlpha := StrToInt(PenAlpha1.Text);
      IEBitmap.AlphaChannel.Canvas.Pen.Color := $02000000 or (iTransparency) or
        (iTransparency shl 8) or (iTransparency shl 16);
      IEBitmap.AlphaChannel.Canvas.Pen.Width := StrToInt(BrushSize1.Text);
      IEBitmap.AlphaChannel.Canvas.Pixels[BX, BY] := PenColor1.Selected;
      IEBitmap.Alpha[BX, BY] := iTransparency;
      Update;
    end;
    with ImageEnView1 do
    begin
      IEBitmap.Canvas.Pen.Width := StrToInt(BrushSize1.Text);
      iTransparency := 0;
      IEBitmap.CanvasCurrentAlpha := StrToInt(PenAlpha1.Text);
      IEBitmap.AlphaChannel.Canvas.Pen.Color := $02000000 or (iTransparency) or
        (iTransparency shl 8) or (iTransparency shl 16);
      IEBitmap.AlphaChannel.Canvas.Pen.Width := StrToInt(BrushSize1.Text);
      IEBitmap.AlphaChannel.Canvas.Pixels[BX, BY] := PenColor1.Selected;
      IEBitmap.Alpha[BX, BY] := iTransparency;
      Update;
      Bitmap.Modified := True;
    end;
  end
  else if (Erase1.Down) and (StrToInt(BrushSize1.Text) > 1) and
    ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or (Shift = [ssTouch]))
  then
  begin
    ADrawing := True;
    EraseBrush(BX, BY);
  end
  else if (Line1.Down) and ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or
    (Shift = [ssTouch])) then
  begin
    ImageEnView1.Proc.SaveUndoCaptioned
      ('Draw Line ' + IntToStr(ImageEnView1.Proc.UndoCount + 1));
    Undo1.Hint := 'Draw Line ' + IntToStr(ImageEnView1.Proc.UndoCount);
    ADrawing := False;
    DrawLine;
  end;
  if (Rectangle1.Down) and ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or
    (Shift = [ssTouch])) then
  begin
    ImageEnView1.Proc.SaveUndoCaptioned('Draw Rectangle ' +
      IntToStr(ImageEnView1.Proc.UndoCount + 1));
    Undo1.Hint := 'Draw Rectangle ' + IntToStr(ImageEnView1.Proc.UndoCount);
    ADrawing := True;
  end
  else if (RoundRectangle1.Down) and
    ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or (Shift = [ssTouch]))
  then
  begin
    ImageEnView1.Proc.SaveUndoCaptioned('Draw Round Rectangle ' +
      IntToStr(ImageEnView1.Proc.UndoCount + 1));
    Undo1.Hint := 'Draw Round Rectangle ' +
      IntToStr(ImageEnView1.Proc.UndoCount);
    ADrawing := False;
  end
  else if (Ellipse1.Down) and ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch])
    or (Shift = [ssTouch])) then
  begin
    ImageEnView1.Proc.SaveUndoCaptioned('Draw Ellipse ' +
      IntToStr(ImageEnView1.Proc.UndoCount + 1));
    Undo1.Hint := 'Draw Ellipse ' + IntToStr(ImageEnView1.Proc.UndoCount);
    ADrawing := False;
  end
  else if (FilledRectangle1.Down) and
    ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or (Shift = [ssTouch]))
  then
  begin
    ImageEnView1.Proc.SaveUndoCaptioned('Draw Filled Rectangle ' +
      IntToStr(ImageEnView1.Proc.UndoCount + 1));
    Undo1.Hint := 'Draw Filled Rectangle ' +
      IntToStr(ImageEnView1.Proc.UndoCount);
    ADrawing := False;
  end
  else if (FilledEllipse1.Down) and
    ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or (Shift = [ssTouch]))
  then
  begin
    ImageEnView1.Proc.SaveUndoCaptioned('Draw Filled Ellipse ' +
      IntToStr(ImageEnView1.Proc.UndoCount + 1));
    Undo1.Hint := 'Draw Filled Ellipse ' +
      IntToStr(ImageEnView1.Proc.UndoCount);
    ADrawing := False;
  end
  else if (FilledRoundRectangle1.Down) and
    ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or (Shift = [ssTouch]))
  then
  begin
    ImageEnView1.Proc.SaveUndoCaptioned('Draw Filled Round Rectangle ' +
      IntToStr(ImageEnView1.Proc.UndoCount + 1));
    Undo1.Hint := 'Draw Filled Round Rectangle ' +
      IntToStr(ImageEnView1.Proc.UndoCount);
    ADrawing := False;
  end
  else if (Fill1.Down) and ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or
    (Shift = [ssTouch])) then
  begin
    ImageEnView1.Proc.SaveUndoCaptioned
      ('Fill ' + IntToStr(ImageEnView1.Proc.UndoCount + 1));
    Undo1.Hint := 'Fill ' + IntToStr(ImageEnView1.Proc.UndoCount);
    ADrawing := False;
    Cast_Color(BX, BY);
  end
  else if (FillAlpha1.Down) and
    ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or (Shift = [ssTouch]))
  then
  begin
    ImageEnView1.Proc.SaveUndoCaptioned
      ('Fill Alpha' + IntToStr(ImageEnView1.Proc.UndoCount + 1));
    Undo1.Hint := 'Fill Alpha' + IntToStr(ImageEnView1.Proc.UndoCount);
    ADrawing := False;
    Cast_Alpha(BX, BY);
  end
  else if (PickColor1.Down) and
    ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or (Shift = [ssTouch]))
  then
  begin
    Pick_Color(BY, BX);
  end
  else if Text1.Down then
  begin
    ImageEnView1.Bitmap.Canvas.Font.name := 'Segoe UI';
    ImageEnView1.Bitmap.Canvas.Font.Height := 16;
    ImageEnView1.Bitmap.Canvas.Font.Color := clYellow;
    IETextOut(ImageEnView1.Bitmap.Canvas, X, Y, 0, Edit1.Text);
    { Draw text on second layer }
    ImageEnView1.Proc.SetTransparentColors(CreateRGB(255, 255, 255),
      CreateRGB(255, 255, 255), 0);
    { Remove the white, making it as transparent }
    ImageEnView1.Proc.AddSoftShadow(2, 3, 3); // add the shadow
  end;
  ImageEnView1.Update;
  SaveAs1.Enabled := ImageEnView1.Bitmap.Modified;
  Undo1.Enabled := ImageEnView1.Proc.CanUndo;
end;

procedure TForm1.ImageEnView1MouseEnter(Sender: TObject);
begin
  if (Draw1.Down) or (Erase1.Down) then
  begin
    ADrawing := True;
    { Turn off the backbuffer drawing }
    ImageEnView1.OnDrawBackBuffer := ImageEnView1DrawBackBuffer;
    ImageEnView1.Update;
  end;
end;

procedure TForm1.ImageEnView1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
  BX, BY: Integer;
  iAlpha: Integer;
  iTransparency: Integer;
  iPoint: TPoint;
begin
  { If scrolling or selecting then exit }
  if (ImageEnView1.MouseInteract = [miScroll]) or
    (ImageEnView1.MouseInteract = [miSelect]) then
    exit;
  BX := ImageEnView1.XScr2Bmp(X);
  BY := ImageEnView1.YScr2Bmp(Y);
  APX := BX - StrToInt(BrushSize1.Text) div 2;
  APY := BY - StrToInt(BrushSize1.Text) div 2;

  { These public vars are used in DrawBackBuffer }
  AMX := X;
  AMY := Y;
  { These public vars are used in DrawBackBuffer }
  iPoint.X := BX;
  iPoint.Y := BY;

  if (BX >= 0) and (BX <= ImageEnView1.IEBitmap.Width - 1) and (BY >= 0) and
    (BY <= ImageEnView1.IEBitmap.Height - 1) then
  begin
    Row1.Caption := 'Row: ' + IntegerToString(BX + 1);
    Column1.Caption := 'Column: ' + IntegerToString(BY + 1);
    StatusBar1.Panels[4].Text := 'Row: ' + IntegerToString(BY + 1);
    StatusBar1.Panels[5].Text := 'Column: ' + IntegerToString(BX + 1);
    iAlpha := ImageEnView1.IEBitmap.Alpha[BX, BY];
    AlphaUnderCursor1.Caption := 'Alpha: ' + IntToStr(iAlpha);
    OpacityUnderCursor1.Caption := 'Opacity: ' +
      IntToStr(IEAlphaToOpacity(iAlpha)) + '%';
    if StrToInt(BrushAlpha1.Text) <> 255 then
      ColorUnderCursor1.Brush.Color :=
        DitherColor(ImageEnView1.IEBitmap.Canvas.Pixels[BX, BY], Round(iAlpha))
    else
      ColorUnderCursor1.Brush.Color :=
        ImageEnView1.IEBitmap.Canvas.Pixels[BX, BY];
    Color1.Caption := 'Color: ' + ColorToPrettyName
      (ColorUnderCursor1.Brush.Color);
    StatusBar1.Panels[6].Text := 'Color: ' + ColorToPrettyName
      (ColorUnderCursor1.Brush.Color);
    if StrToInt(BrushSize1.Text) = 1 then
    begin
      if (ADrawing) then
        ImageEnView1.HighlightedPixel := iPoint
      else
        ImageEnView1.HighlightedPixel := Point(-1, -1);
    end;
  end
  else
  begin
    ImageEnView1.HighlightedPixel := Point(-1, -1);
  end;
  { Draw with ieCanvas }
  if (Draw1.Down) and (StrToInt(BrushSize1.Text) > 1) and
    ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or (Shift = [ssTouch]))
  then
  begin
    ADrawing := True;
    DrawBrush(BX, BY);
  end
  else if (Draw1.Down) and (StrToInt(BrushSize1.Text) = 1) and
    ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or (Shift = [ssTouch]))
  then
  { TIECanvas can not paint a single point so we paint it on the IEBitmap canvas
    here }
  begin
    { Paint point or 1 pixel }
    with ImageEnView1 do
    begin
      Proc.SaveUndo(ieuImage);
      Undo1.Hint := 'Paint ' + IntToStr(Proc.UndoCount + 1);
      IEBitmap.Canvas.Pen.Color := PenColor1.Selected;
      IEBitmap.Canvas.Pen.Width := StrToInt(BrushSize1.Text);
      IEBitmap.Canvas.Pixels[BX, BY] := PenColor1.Selected;
      iTransparency := StrToInt(PenAlpha1.Text);
      IEBitmap.AlphaChannel.Canvas.Pen.Color := $02000000 or (iTransparency) or
        (iTransparency shl 8) or (iTransparency shl 16);
      IEBitmap.AlphaChannel.Canvas.Pen.Width := StrToInt(BrushSize1.Text);
      IEBitmap.AlphaChannel.Canvas.Pixels[BX, BY] := PenColor1.Selected;
      IEBitmap.Alpha[BX, BY] := iTransparency;
      Update;
    end;
    with ImageEnView1 do
    begin
      IEBitmap.Canvas.Pen.Color := PenColor1.Selected;
      IEBitmap.Canvas.Pen.Width := StrToInt(BrushSize1.Text);
      IEBitmap.Canvas.Pixels[BX, BY] := PenColor1.Selected;
      iTransparency := StrToInt(PenAlpha1.Text);
      IEBitmap.AlphaChannel.Canvas.Pen.Color := $02000000 or (iTransparency) or
        (iTransparency shl 8) or (iTransparency shl 16);
      IEBitmap.AlphaChannel.Canvas.Pen.Width := StrToInt(BrushSize1.Text);
      IEBitmap.AlphaChannel.Canvas.Pixels[BX, BY] := PenColor1.Selected;
      IEBitmap.Alpha[BX, BY] := iTransparency;
      Update;
      Bitmap.Modified := True;
    end;
  end
  else if (Erase1.Down) and (StrToInt(BrushSize1.Text) = 1) and
    ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or (Shift = [ssTouch]))
  then
  { TIECanvas can not paint a single point so we paint it on the IEBitmap canvas
    here }
  begin
    { Paint point or 1 pixel }
    with ImageEnView1 do
    begin
      ADrawing := True;
      Proc.SaveUndo(ieuImage);
      Undo1.Hint := 'Erase ' + IntToStr(Proc.UndoCount + 1);
      IEBitmap.Canvas.Pen.Width := StrToInt(BrushSize1.Text);
      iTransparency := 0;
      IEBitmap.CanvasCurrentAlpha := StrToInt(PenAlpha1.Text);
      IEBitmap.AlphaChannel.Canvas.Pen.Color := $02000000 or (iTransparency) or
        (iTransparency shl 8) or (iTransparency shl 16);
      IEBitmap.AlphaChannel.Canvas.Pen.Width := StrToInt(BrushSize1.Text);
      IEBitmap.AlphaChannel.Canvas.Pixels[BX, BY] := PenColor1.Selected;
      IEBitmap.Alpha[BX, BY] := iTransparency;
      Update;
    end;
    with ImageEnView1 do
    begin
      IEBitmap.Canvas.Pen.Width := StrToInt(BrushSize1.Text);
      iTransparency := 0;
      IEBitmap.CanvasCurrentAlpha := StrToInt(PenAlpha1.Text);
      IEBitmap.AlphaChannel.Canvas.Pen.Color := $02000000 or (iTransparency) or
        (iTransparency shl 8) or (iTransparency shl 16);
      IEBitmap.AlphaChannel.Canvas.Pen.Width := StrToInt(BrushSize1.Text);
      IEBitmap.AlphaChannel.Canvas.Pixels[BX, BY] := PenColor1.Selected;
      IEBitmap.Alpha[BX, BY] := iTransparency;
      Update;
      Bitmap.Modified := True;
    end;
  end
  { Erase with ieCanvas }
  else if (Erase1.Down) and (StrToInt(BrushSize1.Text) > 1) and
    ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or (Shift = [ssTouch]))
  then
  begin
    ADrawing := True;
    EraseBrush(BX, BY);
  end
  else if (Line1.Down) and ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or
    (Shift = [ssTouch])) then
  begin
    ADrawing := True;
    DrawLine;
  end
  else if (Rectangle1.Down) and
    ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or (Shift = [ssTouch]))
  then
  begin
    ADrawing := True;
    DrawRectangle;
  end
  else if (RoundRectangle1.Down) and
    ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or (Shift = [ssTouch]))
  then
  begin
    ADrawing := True;
    DrawRoundRectangle;
  end
  else if (Ellipse1.Down) and ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch])
    or (Shift = [ssTouch])) then
  begin
    ADrawing := True;
    DrawEllipse;
  end
  else if (FilledRectangle1.Down) and
    ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or (Shift = [ssTouch]))
  then
  begin
    ADrawing := True;
    DrawFilledRectangle;
  end
  else if (FilledEllipse1.Down) and
    ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or (Shift = [ssTouch]))
  then
  begin
    ADrawing := True;
    DrawFilledEllipse;
  end
  else if (FilledRoundRectangle1.Down) and
    ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or (Shift = [ssTouch]))
  then
  begin
    ADrawing := True;
    DrawFilledRoundRectangle;
  end;
  ImageEnView1.Update;
  SaveAs1.Enabled := ImageEnView1.Bitmap.Modified;
  Undo1.Enabled := ImageEnView1.Proc.CanUndo;
  ALastX := ImageEnView1.XScr2Bmp(X);
  ALastY := ImageEnView1.YScr2Bmp(Y);
end;

procedure TForm1.ImageEnView1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  BX, BY: Integer;
begin
  { If scrolling or selecting then exit }
  if (ImageEnView1.MouseInteract = [miScroll]) or
    (ImageEnView1.MouseInteract = [miSelect]) or (IEHasGestures) then
    exit;
  BX := ImageEnView1.XScr2Bmp(X);
  BY := ImageEnView1.YScr2Bmp(Y);
  if (Draw1.Down) and (StrToInt(BrushSize1.Text) > 1) and
    ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or (Shift = [ssTouch]))
  then
  begin
    { Draw a brush }
    ImageEnView1.Proc.SaveUndoCaptioned
      ('Draw ' + IntToStr(ImageEnView1.Proc.UndoCount + 1));
    Undo1.Hint := 'Draw ' + IntToStr(ImageEnView1.Proc.UndoCount);
    ADrawing := True;
    DrawBrush(BX, BY);
  end
  else if (Erase1.Down) and (StrToInt(BrushSize1.Text) > 1) and
    ((Shift = [ssLeft]) or (Shift = [ssLeft, ssTouch]) or (Shift = [ssTouch]))
  then
  begin
    { Draw a brush }
    ImageEnView1.Proc.SaveUndoCaptioned
      ('Draw ' + IntToStr(ImageEnView1.Proc.UndoCount + 1));
    Undo1.Hint := 'Draw ' + IntToStr(ImageEnView1.Proc.UndoCount);
    ADrawing := True;
    EraseBrush(BX, BY);
  end;
  ImageEnView1.Update;
end;

procedure TForm1.ImageEnView1ViewChange(Sender: TObject; Change: Integer);
begin
  Fit1.Caption := IntegerToString(Round(ImageEnView1.Zoom)) + '%';
end;

procedure TForm1.Line1Click(Sender: TObject);
begin
  ADrawing := False;
  None1.Checked := True;
  ImageEnView1.MouseInteract := [];
end;

procedure TForm1.New1Click(Sender: TObject);
begin
  ImageEnView1.Proc.ClearAllUndo;
  ImageEnView1.Proc.ClearAllRedo;
  FormNewImage := TFormNewImage.Create(Self);
  try
    if FormNewImage.ShowModal = mrOk then
    begin
      ImageEnView1.IEBitmap.Allocate(FormNewImage.ImageWidth,
        FormNewImage.ImageHeight);
      ImageEnView1.IEBitmap.Fill(FormNewImage.Color);
      ImageEnView1.IO.Params.BitsPerSample := FormNewImage.BitsPerSample;
      ImageEnView1.IO.Params.SamplesPerPixel := FormNewImage.SamplesPerPixel;
      if FormNewImage.BitsPerSample * FormNewImage.SamplesPerPixel = 32 then
        ImageEnView1.Proc.SetTransparentColors(ImageEnView1.IEBitmap.Pixels[0,
          ImageEnView1.IEBitmap.Height - 1], ImageEnView1.IEBitmap.Pixels[0,
          ImageEnView1.IEBitmap.Height - 1], 0);
      AFileName := IncludeTrailingPathDelimiter(DocumentsFolder) + 'Untitled' +
        FormNewImage.Extension;
      Caption := 'ImageEn GDI And GDIPlus Drawing- ' + AFileName;
      StatusBar1.Panels[0].Text :=
        EllipsifyText(True, ExtractFilePath(AFileName), Canvas,
        StatusBar1.Panels[0].Width);
      StatusBar1.Panels[1].Text := EllipsifyText(False,
        ExtractFilename(AFileName), Canvas, StatusBar1.Panels[1].Width);
      StatusBar1.Panels[2].Text := 'Width: ' +
        IntegerToString(ImageEnView1.IEBitmap.Width);
      StatusBar1.Panels[3].Text := 'Height: ' +
        IntegerToString(ImageEnView1.IEBitmap.Height);
      StatusBar1.Panels[9].Text := 'Layers: ' +
        IntToStr(ImageEnView1.LayersCount);
    end;
  finally
    FormNewImage.Free;
  end;
end;

procedure TForm1.None1Click(Sender: TObject);
begin
  ImageEnView1.MouseInteract := [];
  EnableTouch(False);
end;

procedure TForm1.Save1Click(Sender: TObject);
{ Save the image. }
begin
  if FileExists(AFileName) then
  begin
    Screen.Cursor := crHourGlass;
    try
      ImageEnView1.IO.SaveToFile(AFileName);
      ImageEnView1.Bitmap.Modified := False;
      Save1.Enabled := False;
      SaveAs1.Enabled := False;
      ImageEnView1.Proc.ClearAllUndo;
      Undo1.Enabled := False;
    finally
      Screen.Cursor := crDefault;
    end;
  end;
end;

procedure TForm1.SaveAs1Click(Sender: TObject);
{ Save the image with a new filename. }
var
  iExtension: string;
begin
  SavePictureDialog1.FileName := ExtractFilename(ImageEnView1.IO.Params.FileName);
  iExtension := ExtractFileExt(ImageEnView1.IO.Params.FileName);
  if (Pos('.', iExtension) > 0) then
  begin
    iExtension := DelText('.', iExtension);
    SavePictureDialog1.DefaultExt := iExtension;
  end;
  if SavePictureDialog1.Execute then
  begin
    AFileName := SavePictureDialog1.FileName;
    Screen.Cursor := crHourGlass;
    try
      Caption := 'ImageEn GDI And GDIPlus Drawing- ' + AFileName;
      ImageEnView1.IO.SaveToFile(AFileName);
      ImageEnView1.Bitmap.Modified := False;
      Save1.Enabled := False;
      SaveAs1.Enabled := False;
      ImageEnView1.Proc.ClearAllUndo;
      Undo1.Enabled := False;
      StatusBar1.Panels[0].Text :=
        EllipsifyText(True, ExtractFilePath(AFileName), Canvas,
        StatusBar1.Panels[0].Width);
      StatusBar1.Panels[1].Text := EllipsifyText(False,
        ExtractFilename(AFileName), Canvas, StatusBar1.Panels[1].Width);
    finally
      Screen.Cursor := crDefault;
    end;
  end;
end;

procedure TForm1.ScrollBarPenOpacity1Change(Sender: TObject);
begin
  PenOpacity1.Text := IntToStr(ScrollBarPenOpacity1.Position);
end;

procedure TForm1.Selection1Click(Sender: TObject);
begin
  ADrawing := False;
  ImageEnView1.MouseInteract := [miSelect];
  Draw1.Down := False;
  Line1.Down := False;
  Fill1.Down := False;
  FillAlpha1.Down := False;
  Rectangle1.Down := False;
  FilledRectangle1.Down := False;
  PickColor1.Down := False;
  RoundRectangle1.Down := False;
  FilledRoundRectangle1.Down := False;
  Ellipse1.Down := False;
  FilledEllipse1.Down := False;
end;

procedure TForm1.Text1Click(Sender: TObject);
begin
  if Text1.Down then
  begin
    ADrawing := False;
    None1.Checked := True;
    ImageEnView1.MouseInteract := [];
    ImageEnView1.IEBitmap.Allocate(ImageEnView1.Width, ImageEnView1.Height);
    ImageEnView1.IEBitmap.Fill(clWhite);
    ImageEnView1.IEBitmap.AlphaChannel.Fill(0);
  end;
  ImageEnView1.Update;
end;

procedure TForm1.ScrollBarBrushOpacity1Change(Sender: TObject);
begin
  BrushOpacity1.Text := IntToStr(ScrollBarBrushOpacity1.Position);
end;

procedure TForm1.UseGDIPlus1Click(Sender: TObject);
{ Use gdi or gdiplus. }
begin
  if not IEGDIPAvailable then
    MessageBox(0, 'GDIPlus is not available.', 'Warning',
      MB_ICONWARNING or MB_OK)
  else
  begin
    if UseGDIPlus1.Checked then
      IEGDIPLoadLibrary
    else
      IEGDIPUnLoadLibrary;
  end;
end;

end.
